/* 020309N1.CPP                                                            */
/* 2002-03-09 programmeerimisolmpiaadi noorema rhma 1. lesande lahendus */
/*    RISTKLIKUD                                                          */
/* Leopold Parts, leopold@math.ut.ee                                       */
/* Testitud: DJGPP 2.0.3, BC++ 3.1                                         */

/*
    Paneme thele, et kui ristklikutel pole hisosa, siis on hendi
    pindala lihtsalt kahe ristkliku pindalade summa. Mis saab aga siis,
    kui hisosa on olemas?

    Kui me lihtsalt liidaksime ristklikute pindalad, siis me saaksime 
    otsitava osa pindala ja lisaks veel hisosa pindala.

    Joonisel: olgu ristklikud A ja B

       A
    --------      hendi pindala S = S1 + S2 + S3 = S(A) + S(B) - S3.
    |      |
    |      |
    |  S1  |
    |      |
    |  ----+-------
    |  |   |      |
    |  | S3|      |
    |  |   |      |
    ---+----  S2  |
       |          |
       |          |
       ------------
            B

    Seega, kui hisosa on thi, ttab lahendus ikka igesti, sest
    lahutatakse 0.

    Thelepanelik tuleb veel olla paari nansi suhtes:

    1. Piirid lubavad ristklikut kuni mtmetega 2000*2000 = 4 000 000,
       seega tuleb kindlasti kasutada andmete jaoks tpi 'long'.

    2. Ristklikud antakse diagonaalide kaudu. Andmeid tuleks hoida htsel
       kujul, et nendega oleks prast mugav manipuleerida. Seega kui meile
       antakse ette vasak lemine ja parem alumine nurk, siis muudame nad
       vasakuks alumiseks ja paremaks lemiseks.

    Ja nagu ikka geomeetrialesannete juures tuleb olla kindel, et programm
    saab hakkama kikide vimalike erijuhtudega (ks ristklik teise sees
    jne)

    hisosa leidmisest on pikemalt piirkondliku vooru 1. lesande nidis-
    lahenduses. Siin seda juttu kordama ei hakata.
*/

#include <fstream.h>
#include <iomanip.h>

long rist[2][4]; // andmed kahe ristkliku kahe nurga kohta
long vastus = 0; // lppvastus

// tagastab minimaalse arvudest a ja b
long min(long a, long b)
{
    if (a < b) return a;
    return b;
} // min()

// tagastab maksimaalse arvudest a ja b
long max(long a, long b)
{
    if (a > b) return a;
    return b;
} // max()

// loeb sisendandmed globaalsesse muutujasse rist
void loeAndmed()
{
    ifstream in("rist.sis"); // avame sisendfaili

    for (int a = 0; a < 2; ++a) // loeme sisse ristklikud
    {
        int temp[4]; // siia loeme esialgu andmed failist
        // failist andmed
        for (int b = 0; b < 4; ++b)
            in >> temp[b];

        rist[a][0] = min(temp[0], temp[2]);
        rist[a][1] = min(temp[1], temp[3]);
        // rist[a] kaks esimest arvu on nd a-nda ristkliku
        // vasaku alumise nurga koordinaadid

        rist[a][2] = max(temp[0], temp[2]);
        rist[a][3] = max(temp[1], temp[3]);
        // viimased kaks arvu on parema lemise nurga koordinaadid
    } // for

    in.close();
} // loeAndmed()

// tagastab ristkliku pindala
long pindala(long rist[4])
{
    return (rist[2] - rist[0]) * (rist[3] - rist[1]);
} // pindala()


// tagastab ristklikute hisosa pindala
long yhisosa(long rist1[4], long rist2[4])
{
    long a, b; // hisosa moodustava ristkliku kljepikkused

    a = min(rist1[2], rist2[2]) - max(rist1[0], rist2[0]);
    b = min(rist1[3], rist2[3]) - max(rist1[1], rist2[1]);

    if (a < 0 || b < 0) return 0; // kui klg negatiivne, siis hisosa pole
    return a * b; // muidu tagastame pindala
} // yhisosa()

// arvutab ristklikute hendi pindala
void arvuta()
{
    // kasutame alguses vaadeldud valemit S = S(A) + S(B) - S(A ja B hisosa)
    vastus = pindala(rist[0]) + pindala(rist[1]) - yhisosa(rist[0], rist[1]);
} // arvuta()

// vljastab vastuse
void valjasta()
{
    ofstream out("rist.val", ios::out); // avame vljundfaili
    out << vastus << endl; // kirjutame vastuse
    out.close(); // sulgeme vljundfaili
} // valjasta()


int main()
{
    loeAndmed();
    arvuta();
    valjasta();
    return 0;
} // main()
