{ 020309N5.PAS                                                              }
{ 2002-03-09 programmeerimisolmpiaadi noorema rhma 5. lesande lahendus   }
{    CLICKOMANIA                                                            }
{ Ahto Truu                                                                 }
{ Testitud: FPC 1.0.4/GO32V2, TPC 6.0                                       }

{$M 32768,0,0}

{ Selle lihtsa lahendusega viks teenida umbes pooled punktid }

{ NB! Funktsioonist tee_kaik on allpool mitu varianti, valige ks }

const
   sisf = 'CLICK.SIS';
   valf = 'CLICK.VAL';
   maxn = 50;                                      { maksimaalne ridade arv }
   maxm = 50;                                    { maksimaalne veergude arv }
   maxl = maxn * maxm div 2;                      { maksimaalne kikude arv }

type
   seis = record                                           { mngulaua seis }
      n, m : integer;                              { veergude ja ridade arv }
      a : array [1..maxn, 1..maxm] of integer;                { laua vljad }
      k : array [1..maxn, 1..maxm] of boolean;           { kas on vaadeldud }
   end;
   kaik = record                                         { he kigu andmed }
      i, j : integer;                                  { vlja koordinaadid }
      k : integer;                                 { kaotatud kobara suurus }
   end;
   logi = record                                               { mngu logi }
      n : integer;                                     { tehtud kikude arv }
      a : array [1..maxl] of kaik;                             { kigud ise }
   end;

{ loeb tekstifailist algseisu }
procedure loe_seis(var f : text; var s : seis);
var i, j : integer;
begin
   readln(f, s.n, s.m);
   for i := s.n downto 1 do begin
      for j := 1 to s.m do
         read(f, s.a[i, j]);
      readln(f);
   end;
end;

{ seab seisu algasendisse -- kski vli ei ole kobaras }
procedure sea_algseis(var s : seis);
var i, j : integer;
begin
   for i := 1 to s.n do
      for j := 1 to s.m do
         s.k[i, j] := false;
end;

{ loeb antud ruudust algava kobara suuruse }
function loe_kobar(var s : seis; i, j : integer) : integer;
   function lk(x, i, j : integer) : integer;
   begin
      lk := 0;
      if (i < 1) or (i > s.n) or (j < 1) or (j > s.m) then
         exit;
      if s.a[i, j] <> x then
         exit;
      if s.k[i, j] then
         exit;
      s.k[i, j] := true;
      lk := 1 +
         lk(x, i - 1, j) + lk(x, i + 1, j) +
         lk(x, i , j - 1) + lk(x, i, j + 1);
   end;
begin
   loe_kobar := 0;
   if s.a[i, j] < 0 then
      exit;
   loe_kobar := lk(s.a[i, j], i, j);
end;

{ "pakib" seisu piki veerge allapoole }
procedure paki_ver(var s : seis);
var i1, i2, j : integer;
begin
   for j := 1 to s.m do begin
      i1 := 1;
      for i2 := 1 to s.n do
         if not (s.a[i2, j] < 0) then begin
            s.a[i1, j] := s.a[i2, j];
            i1 := i1 + 1;
         end;
      for i2 := i1 to s.n do
         s.a[i2, j] := -1;
   end;
end;

{ "pakib" seisu piki ridu vasakule }
procedure paki_hor(var s : seis);
var i, j1, j2 : integer;
begin
   j1 := 1;
   for j2 := 1 to s.m do
      if not (s.a[1, j2] < 0) then begin
         for i := 1 to s.n do
            s.a[i, j1] := s.a[i, j2];
         j1 := j1 + 1;
      end;
   for j2 := j1 to s.m do
      for i := 1 to s.n do
         s.a[i, j2] := -1;
end;

{ teeb kigu }
procedure kliki(var s : seis; i, j : integer);
   procedure kl(x, i, j : integer);
   begin
      if (i < 1) or (i > s.n) or (j < 1) or (j > s.m) then
         exit;
      if s.a[i, j] <> x then
         exit;
      s.a[i, j] := -1;
      kl(x, i - 1, j); kl(x, i + 1, j);
      kl(x, i, j - 1); kl(x, i, j + 1);
   end;
begin
   kl(s.a[i, j], i, j);
   paki_ver(s);
   paki_hor(s);
end;

{ laseb kigu sisestada kasutajal }
function tee_kaik1(var s : seis; var l : logi) : boolean;
   procedure valjasta_seis(var s : seis);
   const x : string = '  abcdefghijklmnopqrstuvwxyz';
   var i, j : integer;
   begin
      write('  ');
      for j := 1 to s.m do
         write(j mod 10);
      writeln;
      for i := s.n downto 1 do begin
         write(i mod 10, ' ');
         for j := 1 to s.m do
            write(x[s.a[i, j] + 2]);
         writeln;
      end;
   end;
var i, j, k : integer;
begin
   valjasta_seis(s);
   readln(i, j);
   sea_algseis(s);
   k := loe_kobar(s, i, j);
   writeln(k, ' ', sqr(k - 2));
   if k > 1 then begin
      l.n := l.n + 1;
      l.a[l.n].i := i;
      l.a[l.n].j := j;
      l.a[l.n].k := k;
      kliki(s, i, j);
   end;
   tee_kaik1 := (i > 0) and (j > 0);
end;

{ ahne, valib alati maksimaalse kobara }
function tee_kaik2(var s : seis; var l : logi) : boolean;
var i, j, k, ip, jp, kp : integer;
begin
   sea_algseis(s);
   kp := 0;
   for i := 1 to s.n do
      for j := 1 to s.m do begin
         k := loe_kobar(s, i, j);
         if k > kp then begin
            ip := i; jp := j; kp := k;
         end;
      end;
   if kp > 1 then begin
      l.n := l.n + 1;
      l.a[l.n].i := ip;
      l.a[l.n].j := jp;
      l.a[l.n].k := kp;
      kliki(s, ip, jp);
      tee_kaik2 := true;
   end else
      tee_kaik2 := false;
end;

{ vaatab 1 sammu vrra ette }
function tee_kaik3(var s : seis; var l : logi) : boolean;
   { seisu hinnang on samavrviliste paaride arv }
   function hinda1(var s : seis) : integer;
   var n, i, j : integer;
   begin
      n := 0;
      for i := 1 to s.n - 1 do
         for j := 1 to s.m do
            if (s.a[i, j] > 0) and (s.a[i, j] = s.a[i + 1, j]) then
               n := n + 1;
      for i := 1 to s.n do
         for j := 1 to s.m - 1 do
            if (s.a[i, j] > 0) and (s.a[i, j] = s.a[i, j + 1]) then
               n := n + 1; { proovige ka 2, 3 -- vertikaalne paar on parem, see ei lagune }
      hinda1 := n;
   end;
   { seisu hinnang on laual olevate kobarate vrtus }
   function hinda2(var s : seis) : longint;
   var i, j : integer; n, k : longint;
   begin
      n := 0;
      for i := 1 to s.n do
         for j := 1 to s.m do begin
            k := loe_kobar(s, i, j);
            if k > 1 then
               n := n + sqr(k);
         end;
      hinda2 := n;
   end;
var i, j, k, ip, jp, kp : integer; h, hp : longint; s1, s2 : seis;
begin
   sea_algseis(s); s1 := s;
   kp := 0; hp := 0;
   for i := 1 to s.n do
      for j := 1 to s.m do begin
         k := loe_kobar(s, i, j);
         if k > 1 then begin
            s2 := s1;
            kliki(s2, i, j);
            h := hinda(s2);
            if h > hp then begin
               ip := i; jp := j; kp := k; hp := h;
            end;
         end;
      end;
   if kp > 1 then begin
      l.n := l.n + 1;
      l.a[l.n].i := ip;
      l.a[l.n].j := jp;
      l.a[l.n].k := kp;
      kliki(s, ip, jp);
      tee_kaik3 := true;
   end else
      tee_kaik3 := false;
end;

{ leiab logi ja lppeisu jrgi mngu skoori }
function loe_skoor(var s : seis; var l : logi) : longint;
var x, y : longint; i : integer;
begin
   x := 0;
   for i := 1 to l.n do begin
      y := l.a[i].k - 2;
      x := x + y * y;
   end;
   if s.a[1, 1] < 0 then
      x := x + 1000;
   loe_skoor := x;
end;

var
   f : text;
   s : seis;
   l : logi;
   i : integer;

begin
   assign(f, sisf); reset(f);
   loe_seis(f, s);
   close(f);

   l.n := 0;
   while tee_kaik(s, l) do
      { ei miskit };

   assign(f, valf); rewrite(f);
   writeln(f, l.n);
   for i := 1 to l.n do
      writeln(f, l.a[i].i, ' ', l.a[i].j);
   writeln(f, loe_skoor(s, l));
   close(f);
end.
