/* 020309V1.CPP                                                            */
/* 2002-03-09 programmeerimisolmpiaadi vanema rhma 1. lesande lahendus  */
/*    KUUBIKUD                                                             */
/* Leopold Parts, leopold@math.ut.ee                                       */
/* Testitud: DJGPP 2.0.3, BC++ 3.1                                         */

/*
    Natukene nitele otsa vaadates ja asja le jrele meldes taipame
    peagi jrgmist: kui niteks pealtvaates on mingis reas 0, siis kik
    tema all olevad kuubikud ja ta ise kaasa arvatud peavad olema lbi-
    paistvad. See on kogu info, mida 0 meile sisendist annab. Kui me
    loeme sisendist arvu 1, siis see ei anna meile peaaegu mingit infot.
    Vtame alustuseks leni lbipaistmatutest kuubikutest koosneva rist-
    tahuka. On selge, et kui me vtame pealt, eest ja kljeltvaate ning
    "puurime" nullide koha pealt lbi risttahuka pealt, eest ja kljelt,
    siis me saame tpselt sisendandmetele vastava pildi. Nd piisab
    ainult allesjnud lbipaistmatud kuubikud kokku lugeda, sest rohkem
    neid enam olla ei saa -- oleme elimineerinud ainult need, mida sisend
    nuab.
*/

#include <fstream.h>
#include <iomanip.h>

const int MAX = 31; // Maksimaalne risttahuka mde
const int LABIPAISTEV = '0'; // lbipaistev -- vtame vrtuseks '0',
                             // et oleks mugav vrrelda sisendiga
const int LABIPAISTMATU = 0; // lbipaistmatu -- kasutame ra, et C++
                             // algvrtustab globaalsed muutujad nullidega

int kuup[MAX][MAX][MAX]; // risttahukas, mis on algvrtustatud nullidega
long vastus; // mitu lbipaistmatut tahku saab olla

// loeb sisendandmed ja ttleb need kigupealt
void loeAndmed()
{
    ifstream in("kuubid.sis"); // avame sisendfaili
    char jada[MAX]; // muutuja, kus hoitakse sisseloetavat rida

    int korgus, laius, sygavus; // tahuka mtmed
    int a, b, c; // tsklimuutujad

    in >> korgus >> laius >> sygavus; // loeme mtmed

    // LOEME SISSE JA TTLEME EESTVAATE
    for (a = 0; a < korgus; ++a) // iga eestvaate rea jaoks alates levalt
    {
        in >> jada; // loeme rea sisse
        for (b = 0; b < laius; ++b) // vaatame igat rea liiget
        {
            if (jada[b] == LABIPAISTEV) // kui see on lbipaistev
                // siis on iga selle 'taga' olev kuubik on ka lbipaistev
                for (c = 0; c < sygavus; ++c)
                    kuup[a][b][c] = LABIPAISTEV;
        } // for b
    } // for a

    // LOEME SISSE JA TTLEME PEALTVAATE
    for (c = 0; c < sygavus; ++c) // iga pealtvaate rea jaoks alates tagant
    {
        in >> jada; // loeme rea sisse
        for (b = 0; b < laius; ++b) // vaatame igat rea liiget
        {
            if (jada[b] == LABIPAISTEV) // kui see on lbipaistev
                // siis on iga selle 'all' olev kuubik on ka lbipaistev
                for (a = 0; a < korgus; ++a)
                    kuup[a][b][c] = LABIPAISTEV;
        } // for b
    } // for c

    // LOEME SISSE JA TTLEME PAREMALTVAATE
    for (a = 0; a < korgus; ++a) // iga paremaltvaate rea jaoks alates vasakult
    {
        in >> jada; // loeme rea sisse
        for (c = 0; c < sygavus; ++c) // vaatame igat rea liiget
        {
            if (jada[c] == LABIPAISTEV) // kui see on lbipaistev
                // siis on iga sellest 'vasakul' olev kuubik on ka lbipaistev
                for (b = 0; b < laius; ++b)
                    kuup[a][b][sygavus - c - 1] = LABIPAISTEV;
                        // massiivi viimane indeks on 'sygavus - c - 1'
                        // sest sygavus suureneb meil 'paremalt' 'vasakule'
                        // aga jada vaatame lbi vasakult paremale. Selles
                        // on selles lihtne veenduda, kui laiust, krgust
                        // ja sgavust kujutavad teljed joonisele lisada.
        } // for c
    } // for a

    in.close(); // sulgeme sisendfaili

    // Nda vaatame lbi kogu risttahuka ja loeme kokku lbipaistmatud kuubikud
    for (a = 0; a < korgus; ++a)
        for (b = 0; b < laius; ++b)
            for (c = 0; c < sygavus; ++c)
                if (kuup[a][b][c] == LABIPAISTMATU)
                    ++vastus;
} //loeAndmed()

// vljastab vastuse
void valjasta()
{
    ofstream out("kuubid.val", ios::out); // avame vljundfaili
    out << vastus << endl; // kirjutame vastuse
    out.close(); // sulgeme faili
} // valjasta()

int main()
{
    loeAndmed();
    valjasta();
    return 0;
} // main()
