{ 020309V2a.PAS                                                             }
{ 2002-03-09 programmeerimisolmpiaadi vanema  rhma 2. lesande lahendus   }
{    TEKSTITOIMETI                                                          }
{ Indrek Jentson                                                            }
{ Testitud: FPC 1.0.4/GO32V2, TPC 6.0                                       }

{
Kirjutada programmeeritav tekstittleja, mis oskab talle antud tekstiga
sooritada jrgmisi operatsioone:
  COPY X     kopeerida tekstist rida X (1 <= X <= N) oma likepuhvrisse
  CUT X      ligata tekstist rida X (1 <= X <= N) oma likepuhvrisse
  PASTE X    lisada puhvris olev rida rea X (1 <= X <= N+1) ette
  SPLIT X Y  poolitada rida X (1 <= X <= N) positsiooni Y (1 <= Y <= L) eest
  JOIN X     hendada read X (1 <= X <= N-1) ja X+1 heks reaks
             (N on ridade arv tekstis ja L on vaadeldava rea pikkus)

Sisend. Tekstifaili TEKST.SIS esimesel real on tdeldava teksti ridade arv N
(1 <= N <= 100) ja jrgmisel N real igahel ks suurtest ja vikestest ladina
thtedest ning thikutest koosnev tekstirida pikkusega kuni 50 mrki. Faili
jrgmisel real on kskude arv K (1 <= K <= 100) ja jrgmisel K real igahel
ks eelloetletud kskudest.

Vljund. Tekstifiali TEKST.VAL esimesele reale vljastada tulemuseks saadud
teksti ridade arv M ja jrgmisele M reale saadud tekst. Vib eeldada, et
ttlemise kigus ei kasva hegi rea pikkus le 50 mrgi. Algseisus on
likepuhvris thi rida.
}

Type

  { Andmestruktuuriks on lihtahel.
    algus --> [1.rida] --> [2.rida] --> ... --> [counter rida] --> Nil
  }

  PRida = ^TRida;

  TRida = record                      { selles kirjes hoiame he rea teksti }
    data : String[200];
    next : PRida;
  end;

  TToimeti = object        { see objekt haldab ridasid ja opereerib nendega }
    counter : Integer;                                     { ridade koguarv }
    algus : PRida;                                { viide esimese rea peale }
    puhver : String[200];                                     { likepuhver }
    constructor Init;
    destructor Done; virtual;
    procedure Show(var f : TEXT);
    function Get(x : Integer): PRida;
    procedure Append(x : Integer; s : String);
    procedure TCopy(x : Integer);
    procedure Cut(x : Integer);
    procedure Paste(x : Integer);
    procedure Split(x, y : Integer);
    procedure Join(x : Integer);
  end;

constructor TToimeti.Init;           { toimeti atribuutide algvrtustamine }
begin
  counter := 0;
  algus := Nil;
  puhver := '';
end;

destructor TToimeti.Done;                       { ridade eemaldamine mlust }
var
  current, next : PRida;
begin
  current := algus;
  while current <> Nil do
    begin
    next := current^.next;
    dispose(current);
    current := next;
    end;
end;

procedure TToimeti.Show(var f : TEXT);           { ridade kirjutamine faili }
var
  current : PRida;
begin
  WriteLn(f, counter);
  current := algus;
  while current <> Nil do
    begin
    WriteLn(f, current^.data);
    current := current^.next;
    end;
end;

function TToimeti.Get(x : Integer) : PRida;         { rea nr X lesotsimine }
var
  n : integer;
  current : PRida;
begin
  n := 1;
  current := algus;
  while (current <> Nil) and (n < x) do
    begin
    current := current^.next;
    n := n + 1;
    end;
  Get := current;
end;

procedure TToimeti.Append(x : Integer; s : String); 
                            { uue rea tekitamine tekstiga S rea nr X jrele }
var
  current, next : PRida;
begin
  if x > 0 then                        { lisamine esimesest reast tahapoole }
    begin
    current := Get(x);
    next := current^.next;
    New(current^.next);
    current^.next^.data := s;
    current^.next^.next := next
    end
  else                                            { lisamine esimesse ritta }
    begin
    next := algus;
    New(algus);
    algus^.data := s;
    algus^.next := next
    end;
  counter := counter + 1;
end;

procedure TToimeti.TCopy(x : Integer);     { rea kopeerimine likepuhvrisse }
var
  current : PRida;
begin
  current := Get(x);
  puhver := current^.data;
end;

procedure TToimeti.Cut(x : Integer);         { rea likamine likepuhvrisse }
var
  prev, current : PRida;
begin
  if x = 1 then
    begin
    current := algus;
    puhver := current^.data;
    algus := current^.next;
    dispose(current);
    counter := counter - 1
    end
  else
    begin
    prev := Get(x-1);
    if prev <> Nil then
      begin
      current := prev^.next;
      puhver := current^.data;
      prev^.next := current^.next;
      dispose(current);
      counter := counter - 1
      end
    else
      puhver := '';
    end
end;

procedure TToimeti.Paste(x : Integer); 
                            { likepuhvris oleva rea lisamine rea nr X ette }
begin
  Append(x-1, puhver);
end;

procedure TToimeti.Split(x, y : Integer); 
                                    { rea poolitamine positsiooni nr Y eest }
var
  current : PRida;
begin
  current := Get(x);
  Append(x, Copy(current^.data,y,length(current^.data)));
  current^.data := Copy(current^.data,1,y-1);
end;

procedure TToimeti.Join(x : Integer);       { ridade nr X ja X+1 hendamine }
var
  current : PRida;
  buffer : String[200];
begin
  current := Get(x);
  buffer := puhver;
  Cut(x+1);
  current^.data := current^.data + puhver;
  puhver := buffer
end;

VAR
  T : TToimeti;
  F, O : TEXT;
  N, I, X, Y, E, A : Integer;
  S : String;
BEGIN
  T.Init;
  { avame sisendfaili }
  Assign(F, 'TEKST.SIS');
  Reset(F);

  { loeme andmed sisse }
  ReadLn(F, N);
  for I := 1 to N do
    begin
    ReadLn(F, S);
    T.Append(I-1, S);
    end;

  { tidame antud ksud }
  ReadLn(F, N);
  for I := 1 to N do
    begin
    ReadLn(F, S);
    if Copy(S,1,3) = 'COP' then
      begin
      Val(Copy(S,6,4),X,E);
      T.TCopy(X)
      end
    else if Copy(S,1,3) = 'CUT' then
      begin
      Val(Copy(S,5,4),X,E);
      T.Cut(X)
      end
    else if Copy(S,1,3) = 'PAS' then
      begin
      Val(Copy(S,7,4),X,E);
      T.Paste(X)
      end
    else if Copy(S,1,3) = 'SPL' then
      begin
      A := Pos(' ', Copy(S,7,9));
      Val(Copy(S,7,A-1),X,E);
      Val(Copy(S,A+7,4),Y,E);
      T.Split(X, Y);
      end
    else if Copy(S,1,3) = 'JOI' then
      begin
      Val(Copy(S,6,4),X,E);
      T.Join(X);
      end;
    end;
  Close(F);

  { kirjutame tulemuse vljundfaili }
  Assign(O, 'TEKST.VAL');
  Rewrite(O);
  T.Show(O);
  Close(O);

  T.Done;
END.
