{ 020309V3x.PAS                                                             }
{ 2002-03-09 programmeerimisolmpiaadi vanema rhma 3. lesande lahendus    }
{    LINKER                                                                 }
{ Ahto Truu                                                                 }
{ Testitud: FPC 1.0.4/GO32V2, TPC 6.0                                       }

{ Alternatiivne topoloogilist sorteerimist kasutav lahendus }

const
   sisf = 'LINKER.SIS';
   valf = 'LINKER.VAL';

{*** suured arvud ja operatsioonid nendega ***}

const
   maxv = 200;                                { 100^100 on 200-kohaline arv }

type
   arv = record
      m : shortint;                                       { mrk: -1, 0, +1 }
      v : array [0..maxv] of shortint;                            { numbrid }
   end;

{ leiab tisarvu mrgi -1, 0, +1 }
function sgn(n : integer) : integer;
begin
   if n < 0 then
      sgn := -1;
   if n = 0 then
      sgn :=  0;
   if n > 0 then
      sgn := +1;
end;

{ A := N }
procedure omista(var a : arv; n : integer);
var i : integer;
begin
   a.m := sgn(n);
   n := abs(n);
   for i := 0 to maxv do begin
      a.v[i] := n mod 10;
      n := n div 10;
   end;
end;

{ A := A * N }
procedure korruta(var a : arv; n : integer);
var k, i : integer;
begin
   a.m := a.m * sgn(n);
   n := abs(n); k := 0;
   for i := 0 to maxv do begin
      k := k + n * a.v[i];
      a.v[i] := k mod 10;
      k := k div 10;
   end;
end;

{ tagastab -1, kui A1 < A2; 0, kui A1 = A2; +1, kui A1 > A2 }
function vordle(var a1, a2 : arv) : integer;
var i : integer;
begin
   if a1.m <> a2.m then begin
      vordle := sgn(a1.m - a2.m);
      exit;
   end;
   for i := maxv downto 0 do begin
      if a1.m * a1.v[i] <> a2.m * a2.v[i] then begin
         vordle := sgn(a1.m * a1.v[i] - a2.m * a2.v[i]);
         exit;
      end;
   end;
   vordle := 0;
end;

{ vljastab A }
procedure valjasta(var f : text; var a : arv);
var i : integer;
begin
   i := maxv;
   while (i > 0) and (a.v[i] = 0) do
      i := i - 1;
   if (a.m < 0) and (a.v[i] > 0) then
      write(f, '-');
   repeat
      write(f, a.v[i]);
      i := i - 1;
   until i < 0;
end;

{*** graaf ja operatsioonid sellega ***}

const
   maxn = 100;                             { maksimaalne graafi tippude arv }
   maxm = 1000;                            { maksimaalne graafi servade arv }

type
   serv = record                                         { he serva andmed }
      kust, kuhu : integer;
      kaal : integer;
      teel : boolean;                            { kas on mingil teel x->b? }
   end;
   tipp = record                                          { he tipu andmed }
      mink, maxk : arv;                  { minimaalne ja maksimaalne kaugus }
      mins, maxs : integer;             { milliste servade kaudu need saadi }
      minp, maxp : integer;                    { teepikkused tippude arvuna }
      veel : integer;                       { mitu serva on veel vaatlemata }
      teel : boolean;                            { kas on mingil teel x->b? }
   end;
   graaf = record
      n, m : integer;                                { tippude, servade arv }
      t : array [1..maxn] of tipp;
      s : array [1..maxm] of serv;
   end;

{ loeb antud failist graafi }
procedure loe_graaf(var f : text; var g : graaf);
var i : integer;
begin
   readln(f, g.n, g.m);
   for i := 1 to g.m do
      readln(f, g.s[i].kust, g.s[i].kuhu, g.s[i].kaal);
end;

{ loendab iga tipu jaoks need servad, mis viivad temast b suunas }
procedure leia_servad(var g : graaf; b : integer);
var i, k1, k2 : integer; u : boolean;
begin
   for i := 1 to g.n do
      g.t[i].veel := 0;

   for i := 1 to g.n do
      g.t[i].teel := false;
   for i := 1 to g.m do
      g.s[i].teel := false;

   g.t[b].teel := true;
   repeat
      u := false;
      for i := 1 to g.m do begin
         k1 := g.s[i].kust; k2 := g.s[i].kuhu;
         if g.t[k2].teel and not g.s[i].teel then begin
            g.t[k1].veel := g.t[k1].veel + 1;
            g.t[k1].teel := true;
            g.s[i].teel := true;
            u := true;
         end;
      end;
   until not u;
end;

{ leiab iga tipu jaoks maksimaalse ja minimaalse kauguse }
procedure leia_kaugused(var g : graaf; b : integer);
var i, k1, k2 : integer; u : boolean; a : arv;
begin
   for i := 1 to g.n do begin
      omista(g.t[i].mink, 0); g.t[i].mins := -1; g.t[i].minp := -1;
      omista(g.t[i].maxk, 0); g.t[i].maxs := -1; g.t[i].minp := -1;
   end;

   omista(g.t[b].mink, 1); g.t[b].mins := 0; g.t[b].minp := 1;
   omista(g.t[b].maxk, 1); g.t[b].mins := 0; g.t[b].maxp := 1;
   repeat
      u := false;
      for i := 1 to g.m do begin
         k1 := g.s[i].kust; k2 := g.s[i].kuhu;
         if (g.t[k2].veel = 0) and g.s[i].teel then begin
            a := g.t[k2].mink; korruta(a, g.s[i].kaal);
            if (g.t[k1].mins < 0) or (vordle(a, g.t[k1].mink) < 0) then begin
               g.t[k1].mink := a; g.t[k1].mins := i;
               g.t[k1].minp := g.t[k2].minp + 1;
            end;
            if (g.t[k1].maxs < 0) or (vordle(a, g.t[k1].maxk) > 0) then begin
               g.t[k1].maxk := a; g.t[k1].maxs := i;
               g.t[k1].maxp := g.t[k2].minp + 1;
            end;

            a := g.t[k2].maxk; korruta(a, g.s[i].kaal);
            if (g.t[k1].mins < 0) or (vordle(a, g.t[k1].mink) < 0) then begin
               g.t[k1].mink := a; g.t[k1].mins := i;
               g.t[k1].minp := g.t[k2].maxp + 1;
            end;
            if (g.t[k1].maxs < 0) or (vordle(a, g.t[k1].maxk) > 0) then begin
               g.t[k1].maxk := a; g.t[k1].maxs := i;
               g.t[k1].maxp := g.t[k2].maxp + 1;
            end;

            g.t[k1].veel := g.t[k1].veel - 1;
            g.s[i].teel := false;
            u := true;
         end;
      end;
   until not u;
end;

{ vljastab antud faili tee a->b }
procedure valjasta_tee(var f : text; var g : graaf; a : integer);
var p, i : integer; max : boolean;
begin
   p := g.t[a].maxp;
   writeln(f, p);
   max := true;
   for i := 1 to p - 1 do begin
      writeln(f, a);
      if max then begin
         if g.s[g.t[a].maxs].kaal < 0 then
            max := not max;
         a := g.s[g.t[a].maxs].kuhu;
      end else begin
         if g.s[g.t[a].mins].kaal < 0 then
            max := not max;
         a := g.s[g.t[a].mins].kuhu;
      end;
   end;
   writeln(f, a);
end;

var
   f : text;
   g : graaf;
   a, b : integer;

begin
   assign(f, sisf); reset(f);
   loe_graaf(f, g);
   readln(f, a, b);
   close(f);

   leia_servad(g, b);
   leia_kaugused(g, b);

   assign(f, valf); rewrite(f);
   valjasta(f, g.t[a].maxk);
   writeln(f);
   valjasta_tee(f, g, a);
   close(f);
end.
