{ kontroll.pas                                                              }
{ 2002-03-09 programmeerimisolmpiaadi vanema rhma 3. lesande testija     }
{    LINKER                                                                 }
{ Ahto Truu                                                                 }

{*** suured arvud ja operatsioonid nendega ***}

const
   maxv = 200;                                { 100^100 on 200-kohaline arv }

type
   arv = record
      m : shortint;                                       { mrk: -1, 0, +1 }
      v : array [0..maxv] of shortint;                            { numbrid }
   end;

{ leiab tisarvu mrgi -1, 0, +1 }
function sgn(n : integer) : integer;
begin
   if n < 0 then
      sgn := -1;
   if n = 0 then
      sgn :=  0;
   if n > 0 then
      sgn := +1;
end;

{ A := N }
procedure omista(var a : arv; n : integer);
var i : integer;
begin
   a.m := sgn(n);
   n := abs(n);
   for i := 0 to maxv do begin
      a.v[i] := n mod 10;
      n := n div 10;
   end;
end;

{ A := A * N }
procedure korruta(var a : arv; n : integer);
var k, i : integer;
begin
   a.m := a.m * sgn(n);
   n := abs(n); k := 0;
   for i := 0 to maxv do begin
      k := k + n * a.v[i];
      a.v[i] := k mod 10;
      k := k div 10;
   end;
end;

{ tagastab -1, kui A1 < A2; 0, kui A1 = A2; +1, kui A1 > A2 }
function vordle(var a1, a2 : arv) : integer;
var i : integer;
begin
   if a1.m <> a2.m then begin
      vordle := sgn(a1.m - a2.m);
      exit;
   end;
   for i := maxv downto 0 do begin
      if a1.m * a1.v[i] <> a2.m * a2.v[i] then begin
         vordle := sgn(a1.m * a1.v[i] - a2.m * a2.v[i]);
         exit;
      end;
   end;
   vordle := 0;
end;

{ loeb failist eraldi real oleva arvu }
procedure loe_arv(var f : text; var a : arv);
var m, i : integer; s : string;
begin
   readln(f, s);
   omista(a, 0);
   m := 1;
   for i := 1 to length(s) do
      if (i = 1) and (s[i] = '-') then
         m := -1
      else if s[i] in ['0'..'9'] then begin
         if s[i] > '0' then
            a.m := 1;
         a.v[length(s) - i] := ord(s[i]) - ord('0');
      end else begin
         writeln('Lubamatu number ''', s[i], '''');
         halt(1);
      end;
   a.m := a.m * m;
end;

{*** graaf ja operatsioonid sellega ***}

const
   maxn = 100;                             { maksimaalne graafi tippude arv }
   maxm = 1000;                            { maksimaalne graafi servade arv }

type
   serv = record                                         { he serva andmed }
      kust, kuhu : integer;
      kaal : integer;
   end;
   graaf = record
      n, m : integer;                                { tippude, servade arv }
      s : array [1..maxm] of serv;
   end;

{ loeb antud failist graafi }
procedure loe_graaf(var f : text; var g : graaf);
var i : integer;
begin
   readln(f, g.n, g.m);
   for i := 1 to g.m do
      readln(f, g.s[i].kust, g.s[i].kuhu, g.s[i].kaal);
end;

{ leiab serva kust->kuhu, eeldab et on limalt ks selline }
function leia_serv(var g : graaf; kust, kuhu : integer) : integer;
var i : integer;
begin
   leia_serv := -1;
   for i := 1 to g.m do
      if (g.s[i].kust = kust) and (g.s[i].kuhu = kuhu) then
         leia_serv := i;
end;

{*** phiprogramm ***}

var
   f : text;
   g : graaf;
   a, b : integer;
   maxp, isep, arvp : arv;
   n, i : integer;
   t1, t2, s : integer;

begin
   if paramcount <> 3 then begin
      writeln('Sntaks on: ', paramstr(0), ' sisendfail summafail vljundfail');
      halt(1);
   end;

   assign(f, paramstr(1)); reset(f);
   loe_graaf(f, g);
   readln(f, a, b);
   close(f);

   assign(f, paramstr(2)); reset(f);
   loe_arv(f, maxp);
   close(f);

   assign(f, paramstr(3)); reset(f);
   loe_arv(f, isep);
   readln(f, n);
   omista(arvp, 1);
   for i := 1 to n do begin
      readln(f, t2);
      if (i = 1) and (t2 <> a) then begin
         writeln('Vale algustipp ', t2);
         halt(1);
      end;
      if (i = n) and (t2 <> b) then begin
         writeln('Vale lpptipp ', t2);
         halt(1);
      end;
      if (i > 1) then begin
         s := leia_serv(g, t1, t2);
         if s < 0 then begin
            writeln('Vale kik ', t1, ' -> ', t2);
            halt(1);
         end;
         korruta(arvp, g.s[s].kaal);
      end;
      t1 := t2;
   end;
   close(f);

   if vordle(isep, arvp) <> 0 then begin
      writeln('Skoor ei vasta teele');
      halt(1);
   end;

   if vordle(maxp, arvp) < 0 then begin
      writeln('Skoor letab maksimaalset!!!');
      halt(1);
   end;
   if vordle(maxp, arvp) > 0 then begin
      writeln('Skoor pole maksimaalne');
      halt(1);
   end;

   writeln('Korras');
end.
