
/* EIO 2002, loppvooru tester - heno ivanov, 06. marts 2002 */

#include <stdio.h>
#include <stdlib.h>

int gm, gn; // gm - ridu, gn - veerge
int algseis[50][50]; // 1,2,3... klikod, 0 - tyhi, -1 - kukutamine

void start(char *sfile) {
    FILE *fi;
    int i, j, t;
    if ((fi = fopen(sfile, "r")) == NULL) {
        printf("VIGA: ei saa avada faili %s\n", sfile);
        exit(0);
    }
    fscanf(fi, "%d %d\n", &gm, &gn);
    for (i = 0; i < gm; i++) {
        for (j = 0; j < gn; j++) {
            fscanf(fi, "%d", &algseis[i][j]);
        }
    }
    fclose(fi);
    printf("algseis loetud: %d %d\n", gm, gn);
}

int summa(char *sfile) {
    FILE *fi;
    int z;
    if ((fi = fopen(sfile, "r")) == NULL) {
        printf("VIGA: ei saa avada faili %s\n", sfile);
        exit(0);
    }
    fscanf(fi, "%d\n", &z);
    fclose(fi);
    printf("punktisumma loetud: %d\n", z);
    return z;
}

printb(int seis[50][50]) {
    int i, j;
    for (i = 0; i < gm; i++) {
        for (j = 0; j < gn; j++) {
            printf("%2d ", seis[i][j]);
        }
        printf("\n");
    }
}

// margib sisse -1
int rfill(int seis[50][50], int st, int i, int j) {
    int l, r, u, d, stc;
    l = r = u = d = stc = 0;
    if (seis[i][j] == st) {
        stc = 1;
        seis[i][j] = -1;
        if (i + 1 < gm) {
            l = rfill(seis, st, i + 1, j);
        }
        if (i - 1 >= 0) {
            r = rfill(seis, st, i - 1, j);
        }
        if (j + 1 < gn) {
            d = rfill(seis, st, i, j + 1);
        }
        if (j - 1 >= 0) {
            u = rfill(seis, st, i, j - 1);
        }
    }
    return (stc + l + r + u + d);
}

compress(int seis[50][50]) {
    int i, j, k;
    int j1, j2;

    // kompressioon ylevalt alla
    for (j = 0; j < gn; j++) {
        for (i = gm - 1; i > 0; i--) {
            while (seis[i][j] == -1) {
                k = i;
                while (k > 0) {
                    seis[k][j] = seis[k - 1][j];
                    k--;
                }
                seis[0][j] = 0;
            };
            if (seis[0][j] == -1) {
                seis[0][j] = 0;
            }
        }
    }

    // paremalt vasakule
    j1 = 0; j2 = 1;
    while (j2 < gn) {
        if (seis[gm - 1][j1] != 0) {
            j1++; j2++;
        }
        if ((seis[gm - 1][j1] == 0) && (j2<gn)) {
            if (seis[gm - 1][j2] != 0) {
                // liiguta rida
                for (i = 0; i < gm; i++) {
                    seis[i][j1] = seis[i][j2];
                    seis[i][j2] = 0;
                }
                j2++;
                j1++;
            } else {
                j2++;
            }
        }
    }
}

main(int argc, char **argv)
{
    int kaike, i, j, res, zscore, score, lscore;
    float kordaja;
    FILE *vfile;
    if (argc < 4) {
        printf("kasutamine:\n\n\t%s clickX.sis clickX.sum clickX.val\n", argv[0]);
        exit(1);
    }

    start(argv[1]);
    zscore = summa(argv[2]);

    score = 0;
    if ((vfile = fopen(argv[3], "r")) == NULL) {
        printf("VIGA: ei saa avada faili %s\n", argv[3]);
        exit(0);
    }
    fscanf(vfile, "%d", &kaike);
    while (kaike > 0) {
        kaike--;
        //printb(algseis);
        fscanf(vfile, "%d %d\n", &i, &j);
        //printf("--- %d %d \n", i, j);
        i = gm - i;
        j--;
        //printf("--- %d %d \n", i, j);
        if (i < 0 || i > gm - 1 || j < 0 || j > gn - 1) {
            printb(algseis);
            printf("VIGA: (%d,%d) ei asu manguvaljal\n", gm - i, j + 1);
            exit(0);
        }
        if (algseis[i][j] == 0) {
            printb(algseis);
            printf("VIGA: (%d,%d) on tyhi!\n", gm  - i , j + 1);
            exit(0);
        }
        res = rfill(algseis, algseis[i][j], i, j);
        if (res == 1) {
            printb(algseis);
            printf("VIGA: (%d,%d) on yksik ruut!\n", gm - i, j + 1);
            exit(0);
        }
        //printf("(%d,%d)\n", i, j);
        compress(algseis);
        score += (res - 2) * (res - 2);
    }

    //printb(algseis);
    if (algseis[gm - 1][0] == 0) { /* plats puhas anname boonust */
        printf("BONUS +1000\n");
        score+=1000;
    }

    fscanf(vfile, "%d", &lscore);
    if (lscore != score) {
        printf("VIGA: summa arvestus vale %d != %d \n", lscore, score);
        exit(0);
    }

    printf("OK: mangu summa = %d\n",score);
    if (score * 2 < zscore) {
        kordaja = 0;
    } else if (2 * (float)score / (float)zscore - 1 < 1.5) {
        kordaja = 2 * (float)score / (float)zscore - 1;
    } else {
        kordaja = 1.5;
    }
    printf("Kordaja: %5.3f\n  skoor: %5.3f\n", kordaja, 4 * kordaja);
    return 0;
}
